import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";

/* eslint-disable no-use-before-define */
import { writeFile } from 'fs';
import { promisify } from 'util';
import createElement from './element';
const pWriteFile = promisify(writeFile);

const createPage = send => ({
  $: function () {
    var _$ = _asyncToGenerator(function* (selector) {
      const _ref = yield send('WebDriver:FindElement', {
        value: selector,
        using: 'css selector'
      }),
            value = _ref.value;

      return createElement(send, value.ELEMENT);
    });

    return function $(_x) {
      return _$.apply(this, arguments);
    };
  }(),
  $$: function () {
    var _$$ = _asyncToGenerator(function* (selector) {
      const values = yield send('WebDriver:FindElements', {
        value: selector,
        using: 'css selector'
      });
      return values.map(value => createElement(send, value.ELEMENT));
    });

    return function $$(_x2) {
      return _$$.apply(this, arguments);
    };
  }(),
  close: () => {
    return send('WebDriver:ExecuteScript', {
      script: 'window.close()'
    });
  },
  evaluate: function () {
    var _evaluate = _asyncToGenerator(function* (target, ...args) {
      if (typeof target === 'function') {
        const _ref2 = yield send('WebDriver:ExecuteAsyncScript', {
          script: `
        const args = Array.prototype.slice.call(arguments, 0, arguments.length - 1)
        const resolve = arguments[arguments.length - 1]
        const result = (${target.toString()})(args)

        Promise.resolve(result)
          .then(resolve)
          .catch((error) => {
            throw error
          })
      `,
          args
        }),
              value = _ref2.value;

        return value;
      }

      const _ref3 = yield send('WebDriver:ExecuteAsyncScript', {
        script: `
        Promise.resolve(${target})
          .then(arguments[0])
          .catch((error) => {
            throw error
          })
      `
      }),
            value = _ref3.value;

      return value;
    });

    return function evaluate(_x3) {
      return _evaluate.apply(this, arguments);
    };
  }(),
  goto: url => {
    return send('WebDriver:Navigate', {
      url
    });
  },
  screenshot: function () {
    var _screenshot = _asyncToGenerator(function* (options = {}) {
      const result = yield send('WebDriver:TakeScreenshot', {
        full: true,
        hash: false
      });
      const buffer = Buffer.from(result.value, 'base64');

      if (typeof options.path === 'string') {
        yield pWriteFile(options.path, buffer);
      }

      return buffer;
    });

    return function screenshot() {
      return _screenshot.apply(this, arguments);
    };
  }(),
  setContent: html => {
    return send('WebDriver:ExecuteScript', {
      script: 'document.documentElement.innerHTML = arguments[0]',
      args: [html]
    });
  },
  title: function () {
    var _title = _asyncToGenerator(function* () {
      const result = yield send('WebDriver:GetTitle');
      return result.value;
    });

    return function title() {
      return _title.apply(this, arguments);
    };
  }()
});

export default createPage;